<template>
  <v-container>
    <v-card :loading="loading" class="mx-auto" outlined>
      <v-list-item three-line>
        <v-list-item-content>
          <v-list-item-title class="text-h5 mb-1">
            <a
              class="btn black--text text-decoration-none"
              :href="`https://ftmscan.com/address/${contractAddress}#readContract`"
              target="_blank"
            >
              Contract Address {{ contractAddress }}</a
            >
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>

      <v-list two-line>
        <v-list-item>
          <v-list-item-content>
            <v-list-item-title>{{
              contractData.totalSupply
            }}</v-list-item-title>
            <v-list-item-subtitle>Total Supply</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
        <v-list-item>
          <v-list-item-content>
            <v-list-item-title class="blue--text text--darken-4"
              >$ {{ contractData.globTokenPrice }}</v-list-item-title
            >
            <v-list-item-subtitle>Average token price</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item>
        <v-list-item>
          <v-list-item-content>
            <v-list-item-title class="red--text text--darken-4"
              >$ {{ contractData.globTokensPrice }}</v-list-item-title
            >
            <v-list-item-subtitle>Price of all tokens</v-list-item-subtitle>
          </v-list-item-content>
        </v-list-item></v-list
      >

      <v-card-actions class="pa-4">
        <v-btn
          depressed
          :loading="loading"
          @click="updateContractData"
          class="primary"
          >Update Data</v-btn
        >
      </v-card-actions>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import { Vue, Component } from "vue-property-decorator";
import Web3 from "web3";
import { getContractABI, getTokenPrice } from "@/api";
import { ContractData, ContractReserves } from "@/utils/types";
import { BigNumber } from "bignumber.js";
import { PROVIDER_HOST, CONTRACT_ADDRESS } from "@/utils";

const web3 = new Web3(PROVIDER_HOST);

const initialContractData: ContractData = {
  totalSupply: "",
  globTokenPrice: "",
  globTokensPrice: "",
};

@Component
export default class HelloWorld extends Vue {
  loading = true;
  contractData: ContractData = { ...initialContractData };
  contractAddress = CONTRACT_ADDRESS;

  async updateContractData(): Promise<void> {
    try {
      this.loading = true;

      const abi = await getContractABI();

      const contract = new web3.eth.Contract(abi, this.contractAddress);

      const {
        _reserve0: weiNumberOf0,
        _reserve1: weiNumberOf1,
      }: ContractReserves = await contract.methods.getReserves().call();

      const token0Address: string = await contract.methods.token0().call();
      const token1Address: string = await contract.methods.token1().call();

      const weiTotalSupply: string = await contract.methods
        .totalSupply()
        .call();
      const totalSupply = web3.utils.fromWei(weiTotalSupply);

      const token0Price = await getTokenPrice(token0Address);
      const token1Price = await getTokenPrice(token1Address);

      const numberOf0 = web3.utils.fromWei(weiNumberOf0);
      const numberOf1 = web3.utils.fromWei(weiNumberOf1);

      const globTokensPrice = new BigNumber(numberOf0)
        .multipliedBy(token0Price)
        .plus(new BigNumber(numberOf1).multipliedBy(token1Price))
        .valueOf();

      const globTokenPrice = new BigNumber(globTokensPrice)
        .dividedBy(totalSupply)
        .valueOf();

      this.contractData = {
        globTokensPrice,
        globTokenPrice,
        totalSupply,
      };
    } finally {
      this.loading = false;
    }
  }
  mounted(): void {
    this.updateContractData();
  }
}
</script>
